<?php
// Система переноса сайта FTPMove 2.1.0
// Скрипт разработан: Михеевым Дмитрием Сергеевичем
// e-mail - dimok@dimok.net
//
// Mod by Gemorroj

header('Content-type: text/html; charset=utf-8');
header('Cache-control: no-cache');

function getchmod($perm)
{
$chmod = 0;
if($perm[0] == 'r'){$chmod = $chmod+0400;}
if($perm[1] == 'w'){$chmod = $chmod+0200;}
if($perm[2] == 'x'){$chmod = $chmod+0100;}
if($perm[3] == 'r'){$chmod = $chmod+0040;}
if($perm[4] == 'w'){$chmod = $chmod+0020;}
if($perm[5] == 'x'){$chmod = $chmod+0010;}
if($perm[6] == 'r'){$chmod = $chmod+0004;}
if($perm[7] == 'w'){$chmod = $chmod+0002;}
if($perm[8] == 'x'){$chmod = $chmod+0001;}
return $chmod;
}


function copy_dir($ftp_from,$ftp_to,$dir_from,$dir_to,$perm,$lev)
{
echo str_repeat('|',$lev-1).'&#187; Создание <strong>'.$dir_to.'</strong>... ';
flush();
$no_errors = true;

if($dir_to[0] == '/')
{$dir_to = substr($dir_to,1);}

$dir_list_to = explode('/',$dir_to);
foreach($dir_list_to as $dir)
{
$dir_exist = false;
$dir_list = ftp_rawlist($ftp_to,'.');
foreach($dir_list as $file)
{
if($file[0] == 'd' && substr($file,strrpos($file,' ')+1) == $dir)
{$dir_exist = true;}
}
if($dir_exist)
{$no_errors = ($no_errors && ftp_site($ftp_to,'chmod 0777 '.$dir) && ftp_chdir($ftp_to,$dir));}
else
{$no_errors = ($no_errors && is_string(ftp_mkdir($ftp_to,$dir)) && ftp_site($ftp_to,'chmod 0777 '.$dir) && ftp_chdir($ftp_to,$dir));}
}

if($no_errors)
{echo '<span class="true">ОK!</span><br/>';}
else
{echo '<strong>Error!</strong><br/>';}
flush();

if(ftp_chdir($ftp_from,$dir_from))
{echo str_repeat('|',$lev-1).'&#187; Переход в <strong>'.$dir_to.'</strong><br/>';}
else
{echo str_repeat('|',$lev-1).'&#187; <strong>Error:</strong> Ошибка перехода в <strong>'.$dir_to.'</strong><br/>';}
flush();

echo str_repeat('|',$lev).'&#187; Чтение содержимого <strong>'.$dir_from.'</strong><br/>';
flush();

$dir_list = ftp_rawlist($ftp_from,'.');

    foreach($dir_list as $file)
      if($file[0] == '-')
      {
        $fperm = substr($file,1,9);
        $fname = substr($file,strrpos($file,' ')+1);
        $chmod = getchmod($fperm);

        echo str_repeat('|',$lev).'&#187; Копирование файла <strong>'.$fname.'</strong>... ';
        flush();

        if((@ftp_get($ftp_from,'tf.fl',$fname,FTP_BINARY) ||
            @ftp_get($ftp_from,'tf.fl',$fname,FTP_ASCII)) &&
           (@ftp_put($ftp_to,$fname,'tf.fl',FTP_BINARY) ||
            @ftp_put($ftp_to,$fname,'tf.fl',FTP_ASCII)) &&
           ftp_site($ftp_to,'chmod '.base_convert($chmod,10,8).' '.$fname) &&
           unlink('tf.fl'))
{echo '<span class="true">ОK!</span><br/>';}
        else
{echo '<strong>Error!</strong><br/>';}
      }

    foreach($dir_list as $file)
      if($file[0] == 'd')
      {
        set_time_limit(300);
        $fperm = substr($file,1,9);
        $fname = substr($file,strrpos($file,' ')+1);

        if($fname <> '.' && $fname <> '..')
        {
echo str_repeat('|',$lev).'&#187; Копирование дирректории <strong>'.$fname.'</strong>...<br/>'; flush();
copy_dir($ftp_from,$ftp_to,$fname,$fname,$fperm,$lev+1);
        }
      }

echo str_repeat('|',$lev).'&#187; Переход <strong>наверх</strong>... '; flush();

      for($j = 0; $j <= substr_count($dir_to,'/'); $j++)
      {ftp_cdup($ftp_to);}

    if(ftp_cdup($ftp_from))
{echo '<span class="true">ОK!</span><br/>';}
    else
{echo '<strong>Error!</strong><br/>';}
    flush();

$chmod = getchmod($perm);
    if(ftp_site($ftp_to,'chmod '.base_convert($chmod,10,8).' '.$dir_to))
{echo str_repeat('|',$lev).'&#187; На <strong>'.$dir_to.'</strong> установлен CHMOD (0'.base_convert($chmod,10,8).')<br/>';}
    else
{echo str_repeat('|',$lev).'&#187; <strong>Error:</strong> Ошибка установки CHMOD (0'.base_convert($chmod,10,8).') на <strong>'.$dir_to.'</strong><br/>';}
flush();
}


if(empty($_POST))
{
exit('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">
<head>
<title>FTP Переезд</title>
<style type="text/css">
body{background-color:#000;color:#fff;font-family"Times New Roman", Times, serif;margin:0;padding:1px;border:3px solid #ebebeb;}
table{background-color:#b00;margin:1%;width:98%;}
input{color:#003;border:1px solid #003;font-weight:bold;margin:0 1%;text-align:center;}
</style>
<script type="text/javascript">
function procform()
{ var f = document.forms[\'cform\'];

  var rexp = /^[a-zA-Z0-9_\d\-\.]{8,64}$/;
  f.host_from.value = f.host_from.value.toLowerCase();
  if (!rexp.test(f.host_from.value))
  { alert(\'Недопустимый FTP-сервер FROM\');
    return false;
  }
  f.host_to.value = f.host_to.value.toLowerCase();
  if (!rexp.test(f.host_to.value))
  { alert(\'Недопустимый FTP-сервер TO\');
    return false;
  }

  rexp = /^[a-zA-Z0-9_\d\-]{4,32}$/;
  f.user_from.value = f.user_from.value.toLowerCase();
  if (!rexp.test(f.user_from.value))
  { alert(\'Недопустимый логин FROM\');
    return false;
  }
  f.user_to.value = f.user_to.value.toLowerCase();
  if (!rexp.test(f.user_to.value))
  { alert(\'Недопустимый логин TO\');
    return false;
  }

  rexp = /^[a-zA-Z0-9_]{4,32}$/;
  if (!rexp.test(f.pass_from.value))
  { alert(\'Недопустимый пароль FROM\');
    return false;
  }
  if (!rexp.test(f.pass_to.value))
  { alert(\'Недопустимый пароль TO\');
    return false;
  }

  f.action = \'index.php\';
  return true;
}
</script>
</head>
<body>
<form id="cform" action="index.php?'.rand(1,999).'" method="post" onsubmit="return procform();">
<table>
<tr>
<td>
<strong style="font-size:14pt;">Съезжаем ОТ:</strong><br/>
<table>
<tr><td>FTP-адрес:</td><td><input name="host_from" type="text" value="ftp."/></td></tr>
<tr><td>Логин:</td><td><input name="user_from" type="text" value="user_from"/></td></tr>
<tr><td>Пароль:</td><td><input name="pass_from" type="text" value="pass_from"/></td></tr>
</table>
Список дирректорий для копирования:<br/>
<textarea name="dir_list_from" rows="5" cols="50"></textarea>
</td>
<td>
<strong style="font-size:14pt;">Съезжаем В:</strong><br/>
<table>
<tr><td>FTP-адрес:</td><td><input name="host_to" type="text" value="ftp."/></td></tr>
<tr><td>Логин:</td><td><input name="user_to" type="text" value="user_to"/></td></tr>
<tr><td>Пароль:</td><td><input name="pass_to" type="text" value="pass_to"/></td></tr>
</table>
Соответствующие имена создаваемых дирректорий:<br/>
<textarea name="dir_list_to" rows="5" cols="50"></textarea>
</td>
</tr>
</table>
<table>
<tr>
<td style="width:10%" valign="top">Примечания:</td>
<td>
* Имя каждой дирректории должно занимать одну строку.<br/>
* Каждой строке дирректорий ОТ должна соответствовать строка дирректорий В.<br/>
* Все имена дирректорий указываются от верхнего уровня Вашего аккаунта.<br/>
* В путях копирования нельзя использовать линки вместо папок, на которые они указывают.<br/>
* Все копируемые дирректории, а также их подпапки должны иметь chmod минимум 500.<br/>
* CHMOD всех файлов в копируемых дирректориях должен быть не менее 400.
</td>
</tr>
</table>
<div style="font-size:12pt;text-align:center;"><input type="submit" value="КОПИРОВАТЬ"/></div>
</form>
</body>
</html>');
}
else
{
print '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">
<head>
<title>FTP Переезд</title>
<style type="text/css">
body{background-color:#000;color:#fff;font-family"Times New Roman", Times, serif;margin:0;padding:1px;border:3px solid #ebebeb;}
.code{background-color:#001;color:#ddd;padding:2pt 1pt 2pt 3pt;margin:1%;border:1px solid #07a;}
.true{color:#070;font-weight:bold;}
</style>
</head>
<body>
<div>';

set_time_limit(3000);
$host_from = trim($_POST['host_from']);
if(preg_match("/[0-255]\.[0-255]\.[0-255]\.[0-255]/", $host_from))
{$ip_from = $host_from;}
else
{$ip_from = @gethostbyname($host_from);}

if(!$ip_from)
{exit('Сервер <strong>'.$host_from.'</strong> НЕ найден</div></body></html>');}
else
{
echo 'Соединение с <strong>'.$host_from.'</strong> ('.$ip_from.')... '; flush();
$ftp_handle_from = @ftp_connect($ip_from);
if(!$ftp_handle_from){exit('Ошибка соединения</div></body></html>');}
else
{echo 'Соединение установлено<br/>';}
echo 'Авторизация <strong>'.$host_from.'</strong>... '; flush();
$user_from = $_POST['user_from'];
$pass_from = $_POST['pass_from'];
if(!@ftp_login($ftp_handle_from,$user_from,$pass_from))
{
echo 'Авторизация не удалась<br/>Выход <strong>'.$host_from.'</strong>... '; flush();
@ftp_quit($ftp_handle_from);
exit('Соединение закрыто</div></body></html>'); flush();
}
else
{echo '<span class="true">ОK!</span><br/>'; flush();}
}


$host_to = trim($_POST['host_to']);
if(preg_match("/[0-255]\.[0-255]\.[0-255]\.[0-255]/", $host_to))
{$ip_to = $host_to;}
else
{$ip_to = @gethostbyname($host_to);}

if(!$ip_to)
{
echo 'Сервер <strong>'.$host_to.'</strong> НЕ найден.<br/>Выход <strong>'.$host_from.'</strong>... '; flush();
@ftp_quit($ftp_handle_from);
exit('Соединение закрыто</div></body></html>'); flush();
}
else
{
echo 'Соединение с <strong>'.$host_to.'</strong> ('.$ip_to.')... '; flush();
$ftp_handle_to = @ftp_connect($ip_to);
if(!$ftp_handle_to)
{
echo 'Ошибка соединения!<br/>Выход <strong>'.$host_from.'</strong>... '; flush();
@ftp_quit($ftp_handle_from);
exit('Соединение закрыто</div></body></html>'); flush();
}
echo 'Соединение установлено.<br/>Авторизация <strong>'.$host_to.'</strong>... '; flush();
$user_to = $_POST['user_to'];
$pass_to = $_POST['pass_to'];
if(!@ftp_login($ftp_handle_to,$user_to,$pass_to))
{
echo 'Авторизация не удалась<br/>Выход <strong>'.$host_to.'</strong>... '; flush();
@ftp_quit($ftp_handle_to);
echo 'Соединение закрыто<br/>'; flush();
echo 'Выход <strong>'.$host_from.'</strong>... '; flush();
@ftp_quit($ftp_handle_from);
exit('Соединение закрыто</div></body></html>'); flush();
}
else
{echo '<span class="true">ОK!</span><br/>'; flush();}
}

$dir_list_from = str_replace("\r\n","\n",$_POST['dir_list_from']);
$dir_list_to = str_replace("\r\n","\n",$_POST['dir_list_to']);

$dir_list_from = explode("\n",$dir_list_from);
$dir_list_to = explode("\n",$dir_list_to);

while(($dir_list_from[0] == '') && (sizeof($dir_list_from) > 1)){array_shift($dir_list_from);}
while(($dir_list_to[0] == '') && (sizeof($dir_list_to) > 1)){array_shift($dir_list_to);}

while($key = array_search('',$dir_list_from))
{
unset($dir_list_from[$key]);
$dir_list_from = array_values($dir_list_from);
}

while($key = array_search('',$dir_list_to))
{
unset($dir_list_to[$key]);
$dir_list_to = array_values($dir_list_to);
}

if($dir_list_from[0] == '')
{echo '<strong>Список дирректорий ОТ не должен быть пустым!</strong><br/>';}
elseif($dir_list_to[0] == '')
{echo '<strong>Список дирректорий В не должен быть пустым!</strong><br/>';}
elseif(($dir_co = sizeof($dir_list_from)) != sizeof($dir_list_to))
{echo '<strong>Количество дирректорий ОТ и дирректорий В должно быть одинаковым!</strong><br/>';}
else
{
echo '<div class="code">';
for($i=0; $i<$dir_co; $i++)
{
$dir_list_from[$i] = str_replace('\\','/',$dir_list_from[$i]);
$dir_list_from[$i] = str_replace('//','/',$dir_list_from[$i]);
if($dir_list_from[$i][0] == '/')
{$dir_list_from[$i] = substr($dir_list_from[$i],1);}

if($pos = strrpos($dir_list_from[$i],'/'))
{
$up_dir_from = substr($dir_list_from[$i],0,$pos);
$copy_dir_from = substr($dir_list_from[$i],$pos+1);
}
else
{
$up_dir_from = '';
$copy_dir_from = $dir_list_from[$i];
}

if($up_dir_from)
{
echo 'Переход в '.$up_dir_from.'... '; flush();
if(@ftp_chdir($ftp_handle_from,$up_dir_from))
{echo '<span class="true">ОK!</span><br/>';}
else
{echo '<strong>Error!</strong><br/>';}
}

$dir_list = @ftp_rawlist($ftp_handle_from,'.');
$perm = '';

foreach($dir_list as $file)
{if($file[0] == 'd' && substr($file,strrpos($file,' ')+1) == $copy_dir_from){$perm = substr($file,1,9); break;}}

if(!$perm)
{echo 'Дирректория <strong>'.$dir_list_from[$i].'</strong> не найдена!<br/>'; flush();}
else
{
echo 'Копирование дирректории <strong>'.$dir_list_from[$i].'</strong> в <strong>'.$dir_list_to[$i].'</strong>...<br/>'; flush();
copy_dir($ftp_handle_from,$ftp_handle_to,$copy_dir_from,$dir_list_to[$i],$perm,1);
}

for($j=0; $j<=substr_count($up_dir_from,'/'); $j++)
{@ftp_cdup($ftp_handle_from);}
}
echo '</div>';
}

echo 'Выход <strong>'.$host_to.'</strong>... '; flush();
@ftp_quit($ftp_handle_to);
echo 'Соединение закрыто<br/>'; flush();
echo 'Выход <strong>'.$host_from.'</strong>... '; flush();
@ftp_quit($ftp_handle_from);
echo 'Соединение закрыто</div></body></html>'; flush();
}
?>